// =====================================================================
// INTERFACE:
//
// void TonelliInit(void) 
//         - Initialises variables
//
// int sqrtmod(mpz_t asqrt, mpz_t a, mpz_t p) 
//         - Tonelli-Shanks: sets asqrt to a square root of a modulo p
//         - Return: 0 if a is not a square mod p, 1 otherwise.
//
// void sqrtmodpk(mpz_t res, mpz_t z, mpz_t a, mpz_t p, int k)
//         - Given a square root z, of a mod p (from Tonelli-Shanks say)
//         - sets res to a square root of a mod p^k
//
// ========================================================================

extern void TonelliInit(void);
extern int32_t sqrtmod(mpz_t, mpz_t, mpz_t);
extern inline void sqrtmodpow(mpz_t, mpz_t, mpz_t, mpz_t);
extern void sqrtmodpk(mpz_t, mpz_t, mpz_t, mpz_t, int32_t);

 
