CPP  = g++
OBJ  = ModuloArith.o TonelliShanks.o F2matrix.o SIMPQS-ver1.o $(RES)
LINKOBJ  = ModuloArith.o TonelliShanks.o F2matrix.o SIMPQS-ver1.o $(RES)
LIBS = -L$(SAGE_LOCAL)/lib -lgmp
INCS = -I$(SAGE_LOCAL)/include
BIN  = QuadraticSieve QuadraticSieve.exe
CXXFLAGS = $(CXXINCS) -Wall -Wno-sign-compare -O2  # -m64 
RM = rm -f

.PHONY: all clean clean-custom

all: QuadraticSieve

clean: clean-custom
	${RM} $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CPP) $(INCS) -ansi $(LINKOBJ) -o "QuadraticSieve" $(LIBS)

ModuloArith.o: ModuloArith.cpp
	$(CPP) $(INCS) -ansi -c ModuloArith.cpp -o ModuloArith.o $(CXXFLAGS)

TonelliShanks.o: TonelliShanks.cpp
	$(CPP) $(INCS) -ansi -c TonelliShanks.cpp -o TonelliShanks.o $(CXXFLAGS)

F2matrix.o: F2matrix.cpp
	$(CPP) $(INCS) -ansi -c F2matrix.cpp -o F2matrix.o $(CXXFLAGS)

SIMPQS-ver1.o: SIMPQS-ver1.cpp
	$(CPP) $(INCS) -ansi -c SIMPQS-ver1.cpp -o SIMPQS-ver1.o $(CXXFLAGS)
